<template>
  <div class="relative inline-flex">
    <button
      ref="trigger"
      class="inline-flex justify-center items-center group w-[103px]"
      aria-haspopup="true"
      @click.prevent="dropdownOpen = !dropdownOpen"
      :aria-expanded="dropdownOpen"
    >
      <svg
        width="32"
        height="32"
        viewBox="0 0 32 32"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        <rect width="32" height="32" rx="16" fill="#334155" />
        <path
          fill-rule="evenodd"
          clip-rule="evenodd"
          d="M26 16L10 24L12.5 16L10 8L26 16Z"
          fill="url(#paint0_linear_2319_9670)"
        />
        <mask
          id="mask0_2319_9670"
          style="mask-type: alpha"
          maskUnits="userSpaceOnUse"
          x="10"
          y="8"
          width="16"
          height="16"
        >
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M26 16L10 24L12.5 16L10 8L26 16Z"
            fill="white"
          />
        </mask>
        <g mask="url(#mask0_2319_9670)">
          <rect
            x="29"
            y="16"
            width="10"
            height="19"
            transform="rotate(90 29 16)"
            fill="url(#paint1_linear_2319_9670)"
          />
        </g>
        <defs>
          <linearGradient
            id="paint0_linear_2319_9670"
            x1="26"
            y1="8"
            x2="10"
            y2="8"
            gradientUnits="userSpaceOnUse"
          >
            <stop stop-color="#A5B4FC" />
            <stop offset="1" stop-color="#818CF8" />
          </linearGradient>
          <linearGradient
            id="paint1_linear_2319_9670"
            x1="30.2269"
            y1="20.6621"
            x2="30.2269"
            y2="35"
            gradientUnits="userSpaceOnUse"
          >
            <stop stop-color="#4338CA" />
            <stop offset="1" stop-color="#6366F1" stop-opacity="0.01" />
          </linearGradient>
        </defs>
      </svg>

      <span
        class="
          truncate
          ml-2
          w-[43px]
          h-[17px]
          text-[14px]
          leading-[17px]
          font-medium font-inter
          group-hover:text-slate-800
        "
        >Admin</span
      >
      <svg
        class="shrink-0 ml-2 fill-current"
        width="12"
        height="12"
        viewBox="0 0 12 12"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          d="M6 9L1 4.23529L2.2963 3L6 6.52941L9.7037 3L11 4.23529L6 9Z"
          fill="#94A3B8"
        />
      </svg>

      <!-- <svg class="w-3 h-3 shrink-0 ml-2 fill-current text-slate-400" viewBox="0 0 12 12">
          <path d="M5.9 11.4L.5 6l1.4-1.4 4 4 4-4L11.3 6z" />
        </svg> -->
    </button>
    <transition
      enter-active-class="transition ease-out duration-200 transform"
      enter-from-class="opacity-0 -translate-y-2"
      enter-to-class="opacity-100 translate-y-0"
      leave-active-class="transition ease-out duration-200"
      leave-from-class="opacity-100"
      leave-to-class="opacity-0"
    >
      <div
        v-show="dropdownOpen"
        class="
          origin-top-right
          z-10
          absolute
          top-full
          min-w-44
          bg-white
          border border-slate-200
          py-1.5
          rounded
          shadow-lg
          overflow-hidden
          mt-1
        "
        :class="align === 'right' ? 'right-0' : 'left-0'"
      >
        <div class="pt-0.5 pb-2 px-3 mb-1 border-b border-slate-200">
          <div class="font-medium text-slate-800">Admin</div>
          <div class="text-xs text-slate-500 italic">Administrator</div>
        </div>
        <ul
          ref="dropdown"
          @focusin="dropdownOpen = true"
          @focusout="dropdownOpen = false"
        >
          <li>
            <Link
              @click="logout"
              class="
                font-medium
                text-sm text-indigo-500
                hover:text-indigo-600
                flex
                items-center
                py-1
                px-3
              "
            >
              Sign Out
            </Link>
          </li>
        </ul>
      </div>
    </transition>
  </div>
</template>

<script>
import { ref, onMounted, onUnmounted } from "vue";
import { postLogout } from "~/api/services/auth.js";
import { Inertia } from "@inertiajs/inertia";
import { Link } from "@inertiajs/inertia-vue3";

export default {
  name: "DropdownProfile",
  props: ["align"],
  components: {
    Link,
  },
  setup() {
    const dropdownOpen = ref(false);
    const trigger = ref(null);
    const dropdown = ref(null);

    // close on click outside
    const clickHandler = ({ target }) => {
      if (
        !dropdownOpen.value ||
        dropdown.value.contains(target) ||
        trigger.value.contains(target)
      )
        return;
      dropdownOpen.value = false;
    };

    // close if the esc key is pressed
    const keyHandler = ({ keyCode }) => {
      if (!dropdownOpen.value || keyCode !== 27) return;
      dropdownOpen.value = false;
    };

    // Logout Button Clicked
    const logout = async () => {
      await postLogout().then((res) => {
        Inertia.visit(route(`login`));
      });
    };

    onMounted(() => {
      document.addEventListener("click", clickHandler);
      document.addEventListener("keydown", keyHandler);
    });

    onUnmounted(() => {
      document.removeEventListener("click", clickHandler);
      document.removeEventListener("keydown", keyHandler);
    });

    return {
      dropdownOpen,
      trigger,
      dropdown,
      logout,
    };
  },
};
</script>